
<p>
    Zusätzlich zum ER-Diagramm werden im Relationenmodell folgende Dinge ersichtlich:
<ul class="ovk-bullet-list">
    <li>Datentyp der Attribute</li>
    <li>Ob ein Attribut angegeben werden muss oder nicht, d.&nbsp;h. ob der Wert <code>Null</code>
        zulässig ist</li>
    <li>Ob für das Attribut ein Standardwert vorliegt (z.&nbsp;B. das Datum des heutigen Tages)</li>
    <li>Über welche Attribute die Tabellen verknüpft sind</li>
</ul>
<p>
    Demnach unterscheidet sich in der Praxis das Relationenmodell vor allem dadurch vom ER-Modell, dass
    es reichhaltiger ist. Die Attribute werden durch zusätzliche Informationen beschrieben (Datentyp,
    NotNull, AutoInc). Außerdem wird ersichtlich, welches Attribut die Verknüpfung zwischen Entitäten
    herstellt.
</p>
<h2>Relationen und Tupel</h2>
<figure style="max-width: 18em; background-color: inherit;" class="ovk-float-right">
    <img style="margin-bottom: 0.5em;"
        src="{{ data 'domain_root' }}/static/Informatik/Datenbanken/Relation_Schematisch.svg"
        alt='Relation' id="bestellformular" />
    <caption>Begriffe im Relationenmodell</caption>
</figure>
<p>
    Relationen kann man sich wie Tabellen vorstellen: Der Relationenname entspricht dem Namen der
    Tabelle. In der Kopfzeile finden wir die Namen der Attribute. Diese Zeile definiert die Struktur der
    Tabelle und es wird ersichtlich, wie viele Spalten diese hat und wie diese benannt sind. Die
    Informationen über die Tabellenstruktur wird auch <span class="bold">Relationenschema</span>
    genannt.
<p>
    Die restlichen Zeilen bilden die eigentliche <b>Relation</b>. Eine einzelne Zeile
    innerhalb dieser Relation heißt <span class="bold">Tupel</span>.
</p>

<h2>Wertebereiche und Datentypen</h2>
<p>
    Anders als beim ER-Modell werden im Relationenmodell den Attribute nun <b>Wertebereiche
        (Datentypen)</b> zugeordnet. Darunter sind die folgenden Wertebereiche, die uns in der
    Programmierung als Datentypen von Variablen bereits begegnet sind:
</p>
<!-- Nav tabs -->
<div class="nav nav-tabs" role="tab">
    <button class="nav-link active" data-bs-toggle="tab" href="#home">Zahl</button>
    <button class="nav-link" data-bs-toggle="tab" href="#menu1">Datum</button>
    <button class="nav-link" data-bs-toggle="tab" href="#menu2">Text</button>
    <button class="nav-link" data-bs-toggle="tab" href="#menu3">Boolescher Wert</button>
</div>

<!-- Tab panes -->
<div class="tab-content ovk-tabs">
    <div class="tab-pane container active" id="home">
        <p>
            Bei einer Zahl wird nach verschiedenen Eigenschaften unterschieden:
        </p>
        <ul class="ovk-bullet-list">
            <li>Ganzzahl Byte: dieser beinhaltet ganze Zahlen von -127 bis 128, also Zahlen
                die höchstens 8 Bit Speicherplatz benötigen</li>
            <li>Ganzzahl Integer: beinhaltet auch ganze Zahlen unter -127 und über 128</li>
            <li>Gleitkommazahl: akzeptiert auch Kommazahlen</li>
        </ul>
        <div class="card ovk-hinweis">
            <div class="card-header">
                <b>Hinweis</b>
            </div>
            <div class="card-body">
                <p>
                    In der Regel werden nur dann Zahlen-Datentypen verwendet, wenn arithmetische
                    Vergleiche oder Operationen auf den Datenwerten angewendet werden sollen.
                    Telefonnummern und Postleitzahlen z.&nbsp;B. werden oft als Text gespeichert.
                </p>
            </div>
        </div>
    </div>
    <div class="tab-pane container fade" id="menu1">
        <p>
            Eignet sich für Datumseingaben, wie zum Beispiel dem Geburtsdatum, Anmeldedatum.
        </p>
    </div>
    <div class="tab-pane container fade" id="menu2">
        <p>
            Enthält nicht nur alphabetische Zeichenketten, sondern auch Zahlenreihen, die
            nicht zum Rechnen benutzt werden. So etwa die Postleitzahl, oder eine Identifikationsnummer.
        </p>
        <p>
            Um den Speicherplatz einzugrenzen, wird hinter Text die maximale Anzahl an Zeichen
            festgelegt.
        </p>
    </div>
    <div class="tab-pane container fade" id="menu3">
        <p>
            Kann entweder den Wert <b>true</b> oder <b>false</b> (wahr/falsch) annehmen.
        </p>
        <p>
            Eignet sich z.&nbsp;B in Situationen, wenn gekennzeichnet werden muss, ob jemand schon
            bezahlt hat, oder verheiratet ist.
        </p>
    </div>
</div>